/**
 * Created by zhang on 2017/9/27.
 */

module.exports = {
    version:'1.0.1',
    common_jspaths:[
        'lib/jquery/jquery-3.2.1.min.js',
        'lib/popper/popper.min.js',
        'lib/bootstrap/bootstrap.min.js',
        'web/building_saas/js/*.js'
    ],
    common_css:[
        'lib/bootstrap/css/bootstrap.min.css',
        'web/building_saas/css/main.css',
        'lib/font-awesome/font-awesome.min.css'
    ],
    login_jspaths:[
        'public/web/url_util.js',
        'web/users/js/login.js'
    ],
    pm_css:['lib/ztree/css/zTreeStyle.css'],
    pm_jspaths:[
        'public/web/date_util.js',
        'public/web/tree_table/tree_table.js',
        'public/web/common_ajax.js',
        'web/building_saas/pm/js/**/*.js',
        'lib/ztree/*.js'
    ],
    main_css:[
        'lib/ztree/css/zTreeStyle.css',
        'lib/spreadjs/sheets/css/gc.spread.sheets.excel2013lightGray.10.0.1.css',
        'lib/spreadjs/views/gc.spread.views.dataview.10.0.0.css',
        'lib/jquery-contextmenu/jquery.contextMenu.css'
    ],
    main_jspaths:[
        'lib/JSExpressionEval_src/*.js',
        '!lib/JSExpressionEval_src/JsHashMap.js',
        'lib/jquery-contextmenu/*.js',
        'lib/lodash/lodash.js',
        'web/building_saas/glj/js/project_glj.js',
        'web/building_saas/glj/js/composition.js',
        'web/building_saas/glj/js/common_spread.js',
        'web/building_saas/glj/js/composition_spread.js',
        'web/building_saas/glj/js/project_glj_spread.js',
        'web/building_saas/glj/js/socket.io.slim.js',
        'public/web/socket/connection.js',
        'public/web/uuid.js',
        'public/web/sheet/sheet_common.js',
        'web/building_saas/main/js/models/calc_program.js',
        'web/building_saas/main/js/views/calc_program_manage.js',
        'public/web/common_ajax.js',
        'public/web/url_util.js',
        'public/web/number_util.js',
        'public/web/sheet/sheet_common.js',
       // 'lib/ztree/*.js',
        'lib/spreadjs/sheets/gc.spread.sheets.all.10.0.1',
       // 'lib/spreadjs/views/gc.spread.views.dataview.10.0.0.min.js',
       // "lib/spreadjs/views/common/gc.spread.common.10.0.0.min.js",
      //  'lib/spreadjs/views/plugins/gc.spread.views.gridlayout.10.0.0.min.js',
        'web/building_saas/main/js/models/main_consts.js',
        'web/building_saas/main/js/models/project.js',
        'web/building_saas/main/js/models/bills.js',
        'web/building_saas/main/js/models/ration.js',
        'web/building_saas/main/js/models/glj.js',
        'web/building_saas/main/js/models/project_glj.js',
        'web/building_saas/main/js/models/fee_rate.js',
        'web/building_saas/main/js/models/ration_glj.js',
        'web/building_saas/main/js/models/ration_coe.js',
        'web/building_saas/main/js/models/ration_ass.js',
        'web/building_saas/main/js/models/volume_price.js',
        'web/building_saas/main/js/models/labour_coe.js',
        'public/web/id_tree.js',
        'test/tmp_data/test_ration_calc/ration_calc_base.js',
        'web/building_saas/main/js/models/cache_tree.js',
        'web/building_saas/main/js/calc/calc_fees.js',
        'web/building_saas/main/js/calc/ration_calc.js',
        'web/building_saas/main/js/calc/bills_calc.js',
        'public/calc_util.js',
        'public/web/tree_sheet/tree_sheet_controller.js',
        'public/web/tree_sheet/tree_sheet_helper.js',
        'public/web/sheet/sheet_data_helper.js',
        'web/building_saas/main/js/views/main_tree_col.js',
        'web/building_saas/main/js/views/project_info.js',
        'web/building_saas/main/js/views/project_view.js',
        'web/building_saas/main/js/views/options_view.js',
        'web/building_saas/main/js/main_ajax.js',
        'web/building_saas/main/js/main.js',
        'web/building_saas/main/js/controllers/project_controller.js',
        'web/building_saas/main/js/views/side_tools.js',
        'web/building_saas/main/js/views/std_bills_lib.js',
        'web/building_saas/main/js/views/std_ration_lib.js',
        'web/building_saas/main/js/models/quantity_detail.js',
        'web/building_saas/main/js/views/glj_view_contextMenu.js',
        'web/building_saas/main/js/views/calc_program_view.js',
        'web/building_saas/main/js/views/confirm_modal.js',
        'public/web/treeDataHelper.js',
        'public/web/ztree_common.js',
        'public/web/rpt_tpl_def.js',
        'web/building_saas/main/js/rpt/rpt_main.js',
        'web/building_saas/main/js/rpt/rpt_cfg_const.js',
        'web/building_saas/main/js/views/character_content_view.js',
        'web/building_saas/main/js/views/glj_view.js',
        'web/building_saas/main/js/views/sub_view.js',
        'web/building_saas/main/js/views/fee_rate_view.js',
        'web/building_saas/main/js/views/sub_fee_rate_views.js',
        'web/building_saas/main/js/views/project_property_labour_coe_view.js'
    ]
}

