/**
 * Created by CSL on 2017-05-12.
 */

var gljOprObj = {
    sheet: null,
    libID: null,
    ration: null,
    sheetData:[],
    coeSheetData:[],
    checkb:null,
    coeSheet:null,
    assSheet:null,
    assSheetData:[],
    detailSheet:null,
    detailData:[],
    GLJSelection:[],
    parentNodeIds:{},
    setting: {
        header: [
            {headerName: "编码", headerWidth: 100, dataCode: "code", dataType: "String", formatter: "@"},
            {headerName: "名称", headerWidth: 120, dataCode: "name", dataType: "String"},
            {headerName: "规格型号", headerWidth: 80, dataCode: "specs", dataType: "String", hAlign: "center"},
            {headerName: "单位", headerWidth: 60, dataCode: "unit", dataType: "String", hAlign: "center"},
            {headerName: "类别", headerWidth: 50, dataCode: "shortName", dataType: "String", hAlign: "center"},
            {headerName: "定额消耗量", headerWidth: 80, dataCode: "rationItemQuantity", dataType: "Number", hAlign: "right",formatter:"0.000",tofix:3},    // dataType: "Number", formatter: "0.00"
            {headerName: "自定义消耗量", headerWidth: 80, dataCode: "customQuantity", dataType: "Number", hAlign: "right",formatter:"0.000",tofix:3},
            {headerName: "消耗量", headerWidth: 80, dataCode: "quantity", dataType: "Number", hAlign: "right",formatter:"0.000",tofix:3},
            {headerName: "基价单价", headerWidth: 80, dataCode: "basePrice", dataType: "Number", hAlign: "right",formatter:"0.00"},
            {headerName: "调整基价", headerWidth: 80, dataCode: "adjustPrice", dataType: "Number", hAlign: "right",formatter:"0.00"},
            {headerName: "市场单价", headerWidth: 80, dataCode: "marketPrice", dataType: "Number", hAlign: "right",formatter:"0.00"},
            {headerName: "市场单价调整", headerWidth: 80, dataCode: "marketPriceAdjust", dataType: "Number", hAlign: "right",formatter:"0.00"},
            {headerName: "是否暂估", headerWidth: 80, dataCode: "isEstimate", dataType: "String", hAlign: "center",vAlign:"center",cellType:"checkBox"}
        ],
        view: {
            comboBox: [{row: -1, col: 12, rowCount: -1, colCount: 1}],
            lockedCells: [{row: -1, col: 3, rowCount: -1, colCount: 1}],
            lockColumns:[0,1,2,3,4,5,7,8,9,10,12]
        },
        notEditedType: ['砼','桨','配比','机']
    },
    coeSetting:{
        header:[
            {headerName: "调整", headerWidth: 100, dataCode: "isAdjust", dataType: "String",cellType:"checkBox"},
            {headerName: "条件", headerWidth: 120, dataCode: "name", dataType: "String",cellType:"button"},
            {headerName: "内容", headerWidth: 350, dataCode: "content", dataType: "String", hAlign: "left"}
        ],
        view:{
            lockColumns:[0,1,2]
        }
    },
    assSetting:{
        header:[
            {headerName: "调整名称", headerWidth: 100, dataCode: "name", dataType: "String"},
            {headerName: "定额值", headerWidth: 120, dataCode: "stdValue", dataType: "String"},
            {headerName: "实际值", headerWidth: 120, dataCode: "actualValue", dataType: "String"}
        ],
        view:{
            lockColumns:[0,1]
        }
    },
    detailSetting:{
        header:[
            {headerName: "名称", headerWidth: 100, dataCode: "name", dataType: "String"},
            {headerName: "计算式", headerWidth: 120, dataCode: "regex", dataType: "String"},
            {headerName: "结果（C）", headerWidth: 120, dataCode: "result", dataType: "Number",formatter:"0.0000",tofix:4},
            {headerName: "累加", headerWidth: 120, dataCode: "isSummation", dataType: "String",cellType:"checkBox"}
        ],
        view:{
            lockColumns:[2,3]
        }
    },
    gljTreeSetting:{
        view: {
            //addHoverDom: gljTypeTreeOprObj.addHoverDom,
            //removeHoverDom: gljTypeTreeOprObj.removeHoverDom,
            expandSpeed: "",
            selectedMulti: false
        },
        edit: {
            enable: false,
            editNameSelectAll: true,
            showRemoveBtn: true,
            showRenameBtn: true,
            removeTitle: "删除节点",
            renameTitle: "更改名称"
        },
        data: {
            keep: {
                parent:true,
                leaf:true
            },
            key: {
                children: "items",
                name: "Name"
            },
            simpleData: {
                enable: false,
                idKey: "ID",
                pIdKey: "ParentID",
                rootPId: -1
            }
        },
        callback:{
            onClick: function(event,treeId,treeNode) {
                let me = gljOprObj, gljTypeId = treeNode.ID;
                if(me.gljCurTypeId !== treeNode.ID){
                    me.gljCurTypeId = treeNode.ID;
                    me.filterLibGLJSheetData();
                    me.showLibGLJSheetData();
                }
            }
        }
    },
    gljLibSheetSetting:{
        owner:'gljTree',
        header: [
            {headerName:"选择", headerWidth: 40, dataCode: "select", hAlign: "center", vAlign: "center",cellType:"checkBox"},
            {headerName:"编码",headerWidth:80,dataCode:"code", dataType: "String", formatter: "@", hAlign: "left", vAlign: "center"},
            {headerName:"名称",headerWidth:120,dataCode:"name", dataType: "String", hAlign: "left", vAlign: "center"},
            {headerName:"规格型号",headerWidth:80,dataCode:"specs", dataType: "String", hAlign: "center", vAlign: "center"},
            {headerName:"计量单位",headerWidth:80,dataCode:"unit", dataType: "String", hAlign: "center", vAlign: "center"},
            {headerName:"单价",headerWidth:80,dataCode:"basePrice", dataType: "Number", formatter: "0.00", hAlign: "right", vAlign: "center"},
            {headerName:"类型",headerWidth:80,dataCode:"gljType", dataType: "String",  hAlign: "center", vAlign: "center"}
        ],
        view:{
            lockColumns:[0,1,2,3,4,5,6]
        }
    },
    gljLibSheet:null,
    initSheet: function(sheet) {
        var me = this;
        me.sheet = sheet;
        sheetCommonObj.initSheet(me.sheet, me.setting, 30);
        sheet.name('ration_glj');
        me.bindSheetEvent(sheet);
        sheet.bind(GC.Spread.Sheets.Events.CellClick, me.onCellClick);
        gljContextMenu.loadGLJSpreadContextMenu();
    },
    initCoeSheet:function (sheet) {
        var me = this;
        me.coeSheet = sheet;
        sheetCommonObj.initSheet(me.coeSheet, me.coeSetting, 30);
        sheet.name('ration_coe');
        me.bindSheetEvent(sheet);
        sheet.bind(GC.Spread.Sheets.Events.CellClick, me.onCoeCellClick);
        subSpread.bind(GC.Spread.Sheets.Events.ButtonClicked,me.onButtonClick);
    },
    initAssSheet: function(sheet) {
        var me = this;
        me.assSheet = sheet;
        sheetCommonObj.initSheet(me.assSheet, me.assSetting, 30);
        sheet.name('ration_ass');
        me.bindSheetEvent(sheet);
    },
    initDetailSheet: function(sheet) {
        var me = this;
        me.detailSheet = sheet;
        sheetCommonObj.initSheet(me.detailSheet, me.detailSetting, 30);
        sheet.name('quantity_detail');
        me.bindSheetEvent(sheet);
    },
    showCoeData:function(sheet,setting,datas){
        sheet.floatingObjects.remove("customerCoe");
        sheetCommonObj.showData(sheet,setting,datas);
        if(datas.length>0){
            var cus_index= _.findIndex(datas,function(item){
                return item.coeID==-1;
            })
            if(cus_index!=-1){
                this.addDropDownList();
               this.addCusButton(cus_index,1,datas[cus_index].name);
            }
        }
    },
    bindSheetEvent:function (sheet) {
        var me = this;
        sheet.bind(GC.Spread.Sheets.Events.ClipboardPasting, me.onClipboardPasting);
        sheet.bind(GC.Spread.Sheets.Events.ClipboardPasted, me.onClipboardPasted);
        sheet.bind(GC.Spread.Sheets.Events.EditEnded, me.onEditEnded);
        sheet.bind(GC.Spread.Sheets.Events.RangeChanged, me.onRangeChanged);
       // sheet.bind(GC.Spread.Sheets.Events.CellClick, me.onCellClick);
    },

    onClipboardPasting: function(sender, args) {
        var me = gljOprObj;
        if (!me.ration) {
            args.cancel = true;
        }
    },

    onClipboardPasted: function(e, info) {
        var me = gljOprObj;
        console.log('past');
      //  if (!me.ration) {return;};
        // your code...
    },

    onEditEnded: function(sender,args){
        var me = gljOprObj;
        if(args.sheetName=='ration_glj'){
            me.onEditGLJSheet(args)
        }
        if(args.sheetName=='ration_ass'){
            me.onEditAssSheet(args);
        }
        if(args.sheetName=='quantity_detail'){
            me.onEditDetailSheet(args);
        }
    },
    onEditDetailSheet:function(args){
        var me = gljOprObj;
        if(args.row>me.detailData.length){
            return;
        }
        if(args.row==me.detailData.length&&args.editingText==null){
            return;
        }
       if(args.row==me.detailData.length){
           projectObj.project.quantity_detail.saveQuantityDetail(args,me.detailSetting.header[args.col].dataCode);
       }
        if(args.row<me.detailData.length){
            projectObj.project.quantity_detail.updateQuantityDetail(args,me.detailSetting.header[args.col].dataCode,me.detailData[args.row]);
        }

    },
    onEditGLJSheet:function(args){
        var me = gljOprObj;
        if(args.row>=me.sheetData.length){
            me.sheet.getCell(args.row, args.col).value(null);
            return;
        }
        var ration_glj = projectObj.project.ration_glj;
        var updateFunction =null;
        if(me.setting.header[args.col].dataCode=='marketPriceAdjust'){//市场单价调整
            updateFunction = ration_glj.marketPriceAdjustUpdate;
        }
        if(me.setting.header[args.col].dataCode=='customQuantity'){//自定义消耗量
            updateFunction = ration_glj.customQuantityUpdate;
        }
        me.updateRationGLJ(args,updateFunction);
    },
    onEditAssSheet:function(args){
        var me = gljOprObj;
        if(args.row>=me.assSheetData.length){
            me.assSheet.getCell(args.row, args.col).value(null);
            return;
        }
        if(me.assSetting.header[args.col].dataCode=='actualValue'){//自定义消耗量
            me.updateRationAss(args);
        }
    },
    onButtonClick:function (sender,args) {
        var me = gljOprObj;
        var sheet = args.sheet, row = args.row, col = args.col;
        var cellType = sheet.getCellType(row, col);
        if (cellType instanceof GC.Spread.Sheets.CellTypes.Button) {
            me.onCusButtonClick(sender,args);
        }else {
           me.onCheckBoxClick(sender,args)
        }
    },
    onCheckBoxClick:function(sender,args){
        if(args.sheetName=='ration_glj'){
            return;
        }
        var checkboxValue = args.sheet.getCell(args.row, args.col).value();
        var newval = 0;
        if(checkboxValue){
            newval = 0;
            args.sheet.getCell(args.row, args.col).value(newval);
        }else {
            newval=1
            args.sheet.getCell(args.row, args.col).value(newval);
        }
        if(args.sheetName=='ration_coe'){
            gljOprObj.updateRationCoe(args,newval)
        }else if(args.sheetName=='quantity_detail'){
            projectObj.project.quantity_detail.isSummationUpdate(args,gljOprObj.detailData,newval);
        }else if(args.sheetName=='glj_lib'){
            gljOprObj.setGLJSelection(args,newval);
        }
    },
    onCusButtonClick:function (sender,args){
        var me = gljOprObj;
        var floatingObject = me.coeSheet.floatingObjects.get('customerCoe');
        var isVisable = floatingObject.isVisible();
        if(!isVisable){
            me.coeSheet.getCell(args.row, args.col, GC.Spread.Sheets.SheetArea.viewport).locked(false);
            me.showFloationObject(floatingObject,me.coeSheetData[args.row]);
        }else {
            var result = me.checkIfNeedUpdate();
            if(result.isNeed){
                projectObj.project.ration_coe.updateCustomerCoe(result);
            }
            floatingObject.isVisible(false);
        }
    },
    onCellClick: function(sender,args){
        var me = gljOprObj;
        if(args.row>=me.sheetData.length){
            return;
        }
        if(me.setting.header[args.col].dataCode=='marketPriceAdjust'){//市场单价调整
            var type = me.sheetData[args.row].shortName;
            var index= _.indexOf(me.setting.notEditedType,type);
            if(index!=-1){
                me.sheet.getCell(args.row, args.col, GC.Spread.Sheets.SheetArea.viewport).locked(true);
            }
        }
    },
    onCoeCellClick:function (sender,args) {
        var me = gljOprObj;
        var floatingObject = me.coeSheet.floatingObjects.get('customerCoe');
        var isVisable = floatingObject.isVisible();
        /*  if($('#dropdown').css("display") == 'none'){
         if(args.col==1&&me.coeSheetData.length>args.row&&me.coeSheetData[args.row].coeID==-1){
         me.showFloationObject(floatingObject,me.coeSheetData[args.row]);
         }
         }*/
        if(isVisable){
            var result = me.checkIfNeedUpdate();
            if(result.isNeed){
                projectObj.project.ration_coe.updateCustomerCoe(result);
            }
            floatingObject.isVisible(false);
           // $('#dropdown').hide();
        }
    },
    showFloationObject(floatingObject,data){
        floatingObject.isVisible(true);
        var sheet = this.coeSheet;
        var startRow = this.coeSheetData.length;
        var endRow = startRow+7;
        floatingObject.startRow(startRow);
        floatingObject.startColumn(1);
        floatingObject.endColumn(2);
        floatingObject.endRow(endRow);
        this.bindFloadingObjectValue(data);
        sheet.repaint();
        // var editPosition = $("#edit").offset();
       //$('#dropdown').show();
        //var top =editPosition.top>=825?825:editPosition.top
        //$('#dropdown').offset({left:editPosition.left,top:top});//top: 791px; left:70px;

    },
    bindFloadingObjectValue(data){
        $('#coe_ration').val(data.coes[0].amount);
        $('#manual').val(data.coes[1].amount);
        $('#material').val(data.coes[2].amount);
        $('#manchine').val(data.coes[3].amount);
        $('#main').val(data.coes[4].amount);
        $('#equipment').val(data.coes[5].amount);
    },
    onInputChange(id,name){
        var coe = _.find(gljOprObj.coeSheetData,function (c) {
            return c.coeID == -1;
        });
        var newValue = gljOprObj.numberValueChecking($('#'+id).val());
        if(newValue){
            newValue=_.round(newValue,2);
            if(newValue==coe.coes[name].amount) return;
            if(id=='coe_ration'){
                $('#coe_ration').val(newValue);
                $('#manual').val(newValue);
                $('#material').val(newValue);
                $('#manchine').val(newValue);
                $('#main').val(newValue);
                $('#equipment').val(newValue);
            }else {
                $('#'+id).val(newValue);
            }
        }else {
            $('#'+id).val(coe.coes[name].amount);
        }
    },
    checkIfNeedUpdate(){
        var data = _.find(gljOprObj.coeSheetData,function (c) {
            return c.coeID == -1;
        });
        var result = {
            isNeed:false
        }
        var coe_ration = $('#coe_ration').val();
        var manual=$('#manual').val();
        var material = $('#material').val();
        var manchine= $('#manchine').val();
        var main = $('#main').val();
        var equipment=$('#equipment').val();
        if(coe_ration!=data.coes[0].amount){
            result.isNeed =true;
            data.coes[0].amount =coe_ration;
        }
        if(manual!=data.coes[1].amount){
            result.isNeed =true;
            data.coes[1].amount =manual;
        }
        if(material!=data.coes[2].amount){
            result.isNeed =true;
            data.coes[2].amount =material;
        }
        if(manchine!=data.coes[3].amount){
            result.isNeed =true;
            data.coes[3].amount =manchine;
        }
        if(main!=data.coes[4].amount){
            result.isNeed =true;
            data.coes[4].amount =main;
        }
        if(equipment!=data.coes[5].amount){
            result.isNeed =true;
            data.coes[5].amount =equipment;
        }
        if(result.isNeed){
            result.doc = {
                coes:data.coes
            };
            result.query = {
                projectID:data.projectID,
                ID:data.ID,
                rationID:data.rationID
            };
        }
        return result;

    },
    addDropDownList:function () {
        var sheet = this.coeSheet;
        sheet.suspendPaint();
        var customFloatingObject = new GC.Spread.Sheets.FloatingObjects.FloatingObject("customerCoe");
        var div = document.createElement('div');
        div.innerHTML = this.generateHtmlString();
        customFloatingObject.startRow(1);
        customFloatingObject.startColumn(1);
        customFloatingObject.endColumn(2);
        customFloatingObject.endRow(2);
        $(div).css('background', 'white');
        customFloatingObject.content(div);
        sheet.floatingObjects.add(customFloatingObject);
        customFloatingObject.isVisible(false);
        sheet.resumePaint();
    },
    addCusButton:function(row,col,text){
        var cus_button = new GC.Spread.Sheets.CellTypes.Button();
        gljOprObj.coeSheet.setCellType(row, col, cus_button, GC.Spread.Sheets.SheetArea.viewport);
        cus_button.marginLeft(0);
        cus_button.marginTop(0);
        cus_button.marginRight(0);
        cus_button.marginBottom(0);
        cus_button.text(text);
        cus_button.buttonBackColor('white');
        gljOprObj.coeSheet.repaint();
    },
    onRangeChanged: function(sender, args) {
        var me = gljOprObj;
        if (args.action == GC.Spread.Sheets.RangeChangedAction.clear) {
            args.editingText=null;
            if(args.sheetName=='ration_glj'){
                me.onEditGLJSheet(args);
            }
            if(args.sheetName=='ration_ass'){
                me.updateRationAss(args);
            }
        };
    },
    generateHtmlString:function () {
//        return "<div id='edit'><div>";

        var newString = "<form ><table border='1px' bordercolor='#CCCCCC' cellspacing='0px' style='border-collapse:collapse;font-size: 10px;>";
        //newString +="<tr><td style='height:15px' colspan='2'>自定义系数</td></tr>"
        newString += this.getOneRow('定额',0,'coe_ration');
        newString += this.getOneRow('人工',1,'manual');
        newString += this.getOneRow('材料',2,'material');
        newString += this.getOneRow('机械',3,'manchine');
        newString += this.getOneRow('主材',4,'main');
        newString += this.getOneRow('设备',5,'equipment');
        newString +="</table></form>";

        return newString;
        //"<form id='edit'><table border='1px' bordercolor='#CCCCCC' cellspacing='0px' style='border-collapse:collapse;font-size: 10px;><tr style='height:10px'><td style='width: 50px'>定额：</td><td style='width: 70px' align='right'><input type='text'value='1' name='ration' style='width:30px;border:0;height:14px' align='right'></td></tr><tr><td>定额：</td><td><input type='text' style='width:50px;border:0;height:10px'></td></tr><tr><td>定额：</td><td><input type='text' style='width:50px;border:0;height:10px'></td></tr><tr ><td>定额：</td><td><input type='text' style='width:50px;border:0;height:10px'></td></tr><tr><td>定额：</td><td><input type='text' style='width:50px;border:0;height:10px'></td></tr></table></form>";
    },
    getOneRow:function (text,name,id) {
        var rowstr = "<tr style='height:10px'><td style='width: 50px'>"+text
            +"：</td><td style='width: 70px' align='right'><input type='text'value='1' name="+name
            +" style='width:30px;border:0;height:14px' align='right' id="+id+" onchange='gljOprObj.onInputChange(this.id,this.name)'></td></tr>";
        return rowstr;

    },

    showDataIfRationSelect:function (node) {
        var isShow = false;
        if(node){
            if(this.selectedNodeId&&this.selectedNodeId==node.getID()){
                return;
            }else {
                this.selectedNodeId=node.getID();
            }
            if(node.sourceType=="ration"){
               this.showRationGLJData(node);
               this.showRationCoeData(node);
               this.showRationAssData(node);
                isShow=true;
            }
            this.showQuantityDetailData(node);
        }else {
            this.selectedNodeId=null;
        }
        if(!isShow){
            this.clearSheetData();
        }
        //hide floatingObject
        var floatingObject = this.coeSheet.floatingObjects.get('customerCoe');
        if(floatingObject){
            floatingObject.isVisible(false);
        }
     //   $('#dropdown').hide();
    },
    showRationGLJData:function (node) {
        var gljList = [];
        var ration_glj = projectObj.project.ration_glj;
        node=node?node:projectObj.project.mainTree.selected;
        if(node.sourceType==ModuleNames.ration){
            let ration = node.data;
            gljList=this.filterGljByRation(ration,ration_glj.datas);
            this.showInSheet(gljList);
        }
    },
    showRationGLJSheetData:function () {
        this.sheetData=_.sortBy(this.sheetData,'type');
        sheetCommonObj.showData(this.sheet,this.setting,this.sheetData);
    },
    filterGljByRation:function (ration,datas) {
        var gljList=[];
        if(datas&&datas.length>0){
            gljList = _.filter(datas,{'rationID':ration.ID})
        }
        return gljList;
    },
    showInSheet:function(gljList){
        this.sheetData=this.combineWithProjectGlj(gljList);
        this.showRationGLJSheetData();
    },
    combineWithProjectGlj:function (ration_gljs) {
        var projectGljs = projectObj.project.projectGLJ.datas.gljList;
        if(ration_gljs&&ration_gljs.length>0&&projectGljs&&projectGljs.length>0){
            ration_gljs.forEach(function (a) {
                var glj = _.find(projectGljs,{id:a.projectGLJID});
                if(glj){
                    a.basePrice=glj.unit_price.base_price;
                    a.marketPrice=glj.unit_price.market_price;
                    a.adjustPrice=glj.adjust_price;
                    a.isEstimate=glj.is_evaluate;
                }
            })
        }
        return ration_gljs;
    }
    ,
    showRationCoeData:function (node) {
        var coeList = [];
        var ration_coe= projectObj.project.ration_coe;
        var ration = node.data;
        if(ration_coe.datas&&ration_coe.datas.length>0){
            coeList = _.filter(ration_coe.datas,{'projectID':ration.projectID,'rationID':ration.ID})
        }
        this.showCoeData(this.coeSheet,this.coeSetting,coeList);
        this.coeSheetData=coeList;
    },
    showRationAssData:function (node) {
        var assList = node.data.rationAssList ? node.data.rationAssList : [];
        sheetCommonObj.showData(this.assSheet,this.assSetting,assList);
        this.assSheetData =assList;
    },
    showQuantityDetailData:function (node) {
        var details=[];
        var quantity_detail =projectObj.project.quantity_detail;
        if(node.sourceType==ModuleNames.ration){
            details=_.filter(quantity_detail.datas,{'rationID':node.data.ID});
        }else if(node.sourceType==ModuleNames.bills){
            details=_.filter(quantity_detail.datas,{'billID':node.data.ID});
        }
        details=_.sortBy(details,'seq');
        sheetCommonObj.showData(this.detailSheet,this.detailSetting,details);
        this.detailData = details;
    },
    clearSheetData:function () {
        sheetCommonObj.showData(this.sheet,this.setting,[]);
        sheetCommonObj.showData(this.coeSheet,this.coeSetting,[]);
        sheetCommonObj.showData(this.assSheet,this.assSetting,[]);
      //  sheetCommonObj.showData(this.detailSheet,this.detailSetting,[]);
        this.sheetData = [];
        this.coeSheetData = [];
        this.assSheetData = [];
        //this.detailData=[];
    },
 /*   lockRationGLJCell:function(){
        sheetCommonObj.lockCells(this.sheet,this.setting);
    },
    lockRationCoeCell:function () {
        sheetCommonObj.lockCells(this.coeSheet,this.coeSetting);
    /!*    if(this.coeSheetData){
            for(var i =0;i<this.coeSheetData.length;i++){
                if(this.coeSheetData[i].coeID==-1){
                    this.coeSheet.getCell(i, 1, GC.Spread.Sheets.SheetArea.viewport).locked(false);
                }
            }
        }*!/

    },
    lockRationGLJCell:function(){
        sheetCommonObj.lockCells(this.sheet,this.setting);
    },*/
    updateRationGLJ:function (args,updateFunction) {
        if(!updateFunction){
            return
        }
        var me = gljOprObj;
        var newval = this.numberValueChecking(args.editingText);
        var recode = me.sheetData[args.row];
        if(args.editingText===null){
            updateFunction.apply(projectObj.project.ration_glj,[recode,null,args.editingText]);
        }else if(newval!=null){
            updateFunction.apply(projectObj.project.ration_glj,[recode,newval,args.editingText]);
        }else {
            newval = recode[me.setting.header[args.col].dataCode];
            me.sheet.getCell(args.row, args.col).value(newval);
        }
    },
    updateRationAss:function (args) {
        var me = gljOprObj;
        var newval;
        newval = me.numberValueChecking(args.editingText);
        var recode = me.assSheetData[args.row];
        if(args.editingText===null){
            newval=parseFloat(recode.stdValue);
        }
        var isValidate = false;
        if(newval){
            isValidate = me.checkingActualValue(recode,newval)
        }
        if(isValidate){
            projectObj.project.ration_ass.updateActualValue(me.assSheetData,args.row,newval)
        }else {
            newval = recode.actualValue;
            me.assSheet.getCell(args.row, args.col).value(newval);
        }
    },

    updateRationCoe:function (args,newval) {
      var me = gljOprObj;
      var recode = me.coeSheetData[args.row];
      projectObj.project.ration_coe.adjustCoeClick(recode,newval);
    },
    numberValueChecking:function (val) {
        var newval = Number(val);
        if(number_util.isNumber(newval)){
            return newval;
        }else {
            if(val){
                alert('您输入的数据类型不正确，请重新输入。');
            }
            newval = null;
        }
        return newval;
    },
    checkingActualValue(record,newval){
        var minExist = record.minValue&&record.minValue!='0'?true:false;
        var maxExist = record.maxValue&&record.maxValue!='0'?true:false;
        var minValue = parseFloat(record.minValue);
        var maxValue = parseFloat(record.maxValue);
        var stdVale = parseFloat(record.stdValue);

        if(!maxExist&&minExist){
            if(newval<minValue){
                alert('实际值应≥'+minValue);
                return false;
            }
        }
        if(maxExist&&!minExist){
            if(newval>maxValue){
                alert('实际值应≤'+maxValue);
                return false;
            }
        }
        if(maxExist&&minExist){
            if(newval<minValue||newval>maxValue){
                alert('实际值应介于'+minValue+'~'+maxValue+'之间');
                return false;
            }
        }
        return true;
    },
    showLibGLJSheetData:function () {
        this.gljLibSheetData=_.sortBy(this.gljLibSheetData, 'code');
        this.gljLibSheet.setRowCount(this.gljLibSheetData.length);
        sheetCommonObj.showData(this.gljLibSheet,this.gljLibSheetSetting,this.gljLibSheetData,gljOprObj.distTypeTree);
    },
    filterLibGLJSheetData:function () {
        let me=this;
        let val = $("input[name='glj']:checked").val();
        if(val=='allGljs'){
            me.gljLibSheetData =me.stdGLJ.concat(me.complementaryGLJs);
        }else {
            me.gljLibSheetData=me[val];
        }
        if($('#actionType').val()!='add'){
            me.filterLibGLJByType();
        }
        if(me.gljCurTypeId==undefined){
            return;
        }
        if (me.parentNodeIds["_pNodeId_" + me.gljCurTypeId]) {
            me.gljLibSheetData= _.filter(me.gljLibSheetData, function(n) {
                return _.includes(me.parentNodeIds["_pNodeId_" + me.gljCurTypeId],n.gljClass);
            });
        } else {
            me.gljLibSheetData = _.filter(me.gljLibSheetData,{'gljClass':me.gljCurTypeId});
        }
    },
    setGLJSelection:function (args,newVal) {
        if($('#actionType').val()=='add'){
            this.addGLJsSelection(args,newVal);
        }else {
            this.replaceGLJSelection(args,newVal);
        }
    },
    addGLJsSelection:function (args,newVal) {
        if(newVal==1){
            this.GLJSelection.push(this.gljLibSheetData[args.row].code);
            this.gljLibSheetData[args.row].select=1;
        }else if(newVal==0){
            _.pull(this.GLJSelection,this.gljLibSheetData[args.row].code);
            this.gljLibSheetData[args.row].select=0;
        }
    },
    replaceGLJSelection:function (args,newVal) {
        var oldSelection=this.GLJSelection[0];
        if(newVal==0){
            args.sheet.getCell(args.row, args.col).value(1);
            return;
        }
        this.GLJSelection=[this.gljLibSheetData[args.row].code];
        this.gljLibSheetData[args.row].select=1;
        var oindex = _.findIndex(this.gljLibSheetData,{'code':oldSelection});
        if(oindex!=-1){
            args.sheet.getCell(oindex, args.col).value(0);
            this.gljLibSheetData[oindex].select=0;
        }else {
            var oldData = _.find(gljOprObj.AllRecode,{'code':oldSelection})
            oldData.select=0;
        }
    },
    filterLibGLJByType:function () {
        var me=this;
        var selected=me.sheetData[gljContextMenu.selectedRow];
        me.gljLibSheetData=_.filter(me.gljLibSheetData,{'gljType':selected.type});
    },
    getComboData: function (gljDistType) {
        let me = this;
        let distType;
        let distTypeTree = {
            prefix : 'gljType',
            distTypes: {},
            comboDatas: [],
            distTypesArr: []
        };
        gljDistType.forEach(function (typeData) {
            let typeObj = {
                data: typeData,
                children: [],
                parent: null
            }
            distTypeTree.distTypes[distTypeTree.prefix + typeData.ID] = typeObj;
            distTypeTree.distTypesArr.push(typeObj);
        });
        gljDistType.forEach(function (typeData) {
            distType = distTypeTree.distTypes[distTypeTree.prefix + typeData.ID];
            let parent = distTypeTree.distTypes[distTypeTree.prefix + typeData.ParentID];
            if(parent){
                distType.parent = parent;
                parent.children.push(distType);
            }
        });
        distTypeTree.distTypesArr.forEach(function (distTypeObj) {
            if(distTypeObj.data.fullName !== '材料' && distTypeObj.data.fullName !== '机械'){
                distTypeTree.comboDatas.push({text: distTypeObj.data.fullName, value: distTypeObj.data.ID});
            }
        });
        return distTypeTree;
    },
    doAddGLJ:function () {
        var selected = projectObj.project.mainTree.selected;
        var project= projectObj.project;
        gljOprObj.GLJSelection= _.filter(gljOprObj.GLJSelection,function (n) {
            return _.find(gljOprObj.sheetData,{'code':n})?false:true;
        })
        if(gljOprObj.GLJSelection.length>0&&selected&&selected.sourceType==ModuleNames.ration){
            project.ration_glj.addGLJByLib(gljOprObj.GLJSelection,selected.data,function (result) {
                if(result){
                    selected.data.adjustState=result.adjustState;
                    project.ration_glj.datas = project.ration_glj.datas.concat(result.newRecodes);
                    gljOprObj.sheetData = gljOprObj.sheetData.concat(result.showData)
                    gljOprObj.showRationGLJSheetData();
                    project.projectGLJ.loadData();
                    projectObj.mainController.refreshTreeNode([selected]);
                    $("#glj_tree_div").modal('hide');
                }
            });//doc.rationID=selected.data.ID;
        }else {
            $("#glj_tree_div").modal('hide');
        }

    },
    doReplaceGLJ:function () {
        var me=this;
        var oldData=me.sheetData[gljContextMenu.selectedRow];
        var project= projectObj.project;
        var selectCode=gljOprObj.GLJSelection[0];
        var selected = projectObj.project.mainTree.selected;
        project.ration_glj.replaceGLJ(selectCode,oldData,function (result) {
            if(result){
                //result.adjustState;
                var data =result.data;
                var index = _.findIndex(gljOprObj.sheetData,{'ID':data.ID});
                gljOprObj.sheetData[index]=data;
                gljOprObj.showRationGLJSheetData();
                project.projectGLJ.loadData();
                selected.data.adjustState=result.adjustState;
                projectObj.mainController.refreshTreeNode([selected]);
            }
            $("#glj_tree_div").modal('hide');
        })
    },
    doMReplaceGLJ:function () {
        var me=this;
        var oldData=me.sheetData[gljContextMenu.selectedRow];
        var project= projectObj.project;
        var selectCode=me.GLJSelection[0];
        project.ration_glj.mReplaceGLJ(selectCode,oldData,function (result) {
            var data=result.data;
            var stateList= result.stateList;
            _.forEach(project.ration_glj.datas,function (t) {
                if(t.code==data.query.code&&t.name==data.query.name){
                    me.updateProperty(t,data.doc);
                }
            })
            me.showRationGLJSheetData();
            project.projectGLJ.loadData();
            me.refreshStateAfterMreplace(stateList);
            $("#glj_tree_div").modal('hide');
        })
    },
    updateProperty:function (obj,doc) {
        _.forEach(doc, function(n, key) {
            obj[key] = n;
        });
    },
    refreshStateAfterMreplace:function (stateList) {
        var nodes=[];
        _.forEach(stateList,function (s) {
          var node = _.find(projectObj.project.mainTree.items,function (n) {
              return n.sourceType==ModuleNames.ration&&n.data.ID==s.rationID;
          })
          if(node){
              node.data.adjustState=s.adjustState;
              nodes.push(node);
          }
        });
        projectObj.mainController.refreshTreeNode(nodes);
    },
    refreshView:function () {
        this.showRationGLJData();
    }
}

$(function(){
    $('#glj_tree_div').on('shown.bs.modal', function (e) {
        if(gljOprObj.gljLibSpresd==undefined){
            gljOprObj.gljLibSpresd=sheetCommonObj.buildSheet($('#gljLibSheet')[0], gljOprObj.gljLibSheetSetting, gljOprObj.stdGLJ.length+gljOprObj.complementaryGLJs.length);
            gljOprObj.gljLibSpresd.bind(GC.Spread.Sheets.Events.ButtonClicked,gljOprObj.onButtonClick);
            gljOprObj.gljLibSheet = gljOprObj.gljLibSpresd.getSheet(0);
            gljOprObj.gljLibSheet.options.isProtected = true;
            gljOprObj.gljLibSheet.name('glj_lib');
        }
        gljOprObj.gljLibSheetData =gljOprObj.AllRecode;
        var selected=null;
        if($('#actionType').val()=='add'){
            gljOprObj.GLJSelection=[];
        }else {
             selected=gljOprObj.sheetData[gljContextMenu.selectedRow];
            gljOprObj.GLJSelection=[selected.code];
            gljOprObj.filterLibGLJByType();
        }

        if(selected!=null){
            var r = _.find(gljOprObj.gljLibSheetData,{'code':selected.code});
            r?r.select=1:"";
        }
        gljOprObj.showLibGLJSheetData();
    });

    $('.glj-radio').change(function () {
        let val = $("input[name='glj']:checked").val();
        if(val=='allGljs'){
            gljOprObj.gljLibSheetData =gljOprObj.AllRecode;
            gljOprObj.filterLibGLJSheetData();
            gljOprObj.showLibGLJSheetData();
        }else {
            gljOprObj.gljLibSheetData=gljOprObj[val];
            gljOprObj.filterLibGLJSheetData();
            gljOprObj.showLibGLJSheetData();
        }
     })
    $('#glj_selected_conf').click(function () {
        if(gljOprObj.GLJSelection.length<1){
            return;
        }
        if($('#actionType').val()=='add'){
            gljOprObj.doAddGLJ();
        }else if($('#actionType').val()=='replace'){
            gljOprObj.doReplaceGLJ();
        }else if($('#actionType').val()=='m_replace'){
            gljOprObj.doMReplaceGLJ();
        }
    })
})



