/**
 * Created by Zhong on 2017/9/28.
 */
let optionsOprObj = {
    options: null,
    optionsTypes: {GENERALOPTS: 'GENERALOPTS'},
    rationQuanACToBillsQuan: $('#generalOpts1'),
    rationQuanACToRationUnit: $('#generalOpts2'),
    getOptions: function () {
        let me = this;
        $.ajax({
            type: 'post',
            url: '/options/getOptions',
            dataType: 'json',
            success: function (result) {
                if(!result.error){
                   me.options = result.data;
                    for(let i = 0, len = me.options.length; i < len; i++){
                        let optsType = me.options[i].type,
                            opts = me.options[i].opts;
                        if(optsType === me.optionsTypes.GENERALOPTS){
                            for(let attr in opts){
                                me[attr][0].checked = opts[attr];
                            }
                        }
                    }
                }
            }
        });
    },
    saveOptions: function (optsType, opts) {
        $.ajax({
            type: 'post',
            url: '/options/saveOptions',
            data: {optsType: optsType, opts: JSON.stringify(opts)},
            dataType: 'json',
            success: function (result) {

            }
        })
    },
    //更新optionsOprObj对象options数据
    updateOptions: function (options, updateObj) {
        for(let i = 0, len = options.length; i < len; i++){
            if(options[i].type === updateObj.type){
                options[i].opts[updateObj.opt] = updateObj.value;
                break;
            }
        }
    },
    getOptsByType: function (options, type) {
        let rst = null;
        for(let i = 0, len = options.length; i < len; i++){
            if(options[i].type === type){
                rst = options[i].opts;
            }
        }
        return rst;
    },
    getOption: function (type, optionName) {
        let opts = this.getOptsByType(this.options, type);
        return opts[optionName];
    }
};

optionsOprObj.getOptions();
optionsOprObj.rationQuanACToBillsQuan.click(function () {
    let value = this.checked;
    optionsOprObj.updateOptions(optionsOprObj.options, {type: optionsOprObj.optionsTypes.GENERALOPTS, opt: 'rationQuanACToBillsQuan', value: value});
    optionsOprObj.saveOptions(optionsOprObj.optionsTypes.GENERALOPTS, optionsOprObj.getOptsByType(optionsOprObj.options, optionsOprObj.optionsTypes.GENERALOPTS));
});
optionsOprObj.rationQuanACToRationUnit.click(function () {
    let value = this.checked;
    optionsOprObj.updateOptions(optionsOprObj.options, {type: optionsOprObj.optionsTypes.GENERALOPTS, opt: 'rationQuanACToRationUnit', value: value});
    optionsOprObj.saveOptions(optionsOprObj.optionsTypes.GENERALOPTS, optionsOprObj.getOptsByType(optionsOprObj.options, optionsOprObj.optionsTypes.GENERALOPTS));
});
