/**
 * Created by Mai on 2017/6/21.
 */

var projectInfoObj = {
    projectInfo: null,
    getFullPathHtml: function (proj) {
        let fullPath = [], i, pm = '<span class="text-truncate"><a href="/pm">项目管理</a></span>', angleRight = '<span class="text-truncate"><i class="fa fa-angle-right fa-fw"></i></span>';
        fullPath.push(pm);
        if (proj && proj.fullFolder) {
            for (i = 0; i < proj.fullFolder.length; i++) {
                if (i <= proj.fullFolder.length - 3) {
                    fullPath.push(angleRight, '<span class="text-truncate" data-toggle="tooltip" data-placement="bottom" title="', proj.fullFolder[i], '"><i class="fa fa-folder-open-o"></i></span>');
                } else if (i === proj.fullFolder.length - 2) {
                    fullPath.push(angleRight, '<span class="text-truncate" data-toggle="tooltip" data-placement="bottom" title="' + proj.fullFolder[i] + '"><i class="fa fa-cubes"></i>' + proj.fullFolder[i] + '</span>');
                } else if (i === proj.fullFolder.length - 1) {
                    fullPath.push(angleRight, '<span class="text-truncate" data-toggle="tooltip" data-placement="bottom" title="' + proj.fullFolder[i] + '"><i class="fa fa-cube"></i>' + proj.fullFolder[i] + '</span>');
                }
            }
            fullPath.push(angleRight, '<span class="text-truncate" data-toggle="tooltip" data-placement="bottom" title="' + proj.name + '"><i class="fa fa-sticky-note-o"></i>' + proj.name + '</span>');
        }
        return fullPath.join('');
    },
    showProjectInfo: function (proj) {
        var that = this;
        CommonAjax.post('/pm/api/getProject', {"user_id": userID, "proj_id": scUrlUtil.GetQueryString('project')}, function (data) {
            if (data) {
                that.projectInfo = data;
                $('#fullpath').html(that.getFullPathHtml(that.projectInfo));
            }
        });
    }
};
